"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _googleSpreadsheet = _interopRequireDefault(require("google-spreadsheet"));

var _gatsbyNodeHelpers = _interopRequireDefault(require("gatsby-node-helpers"));

// gatsby-node.js
const _createNodeHelpers = (0, _gatsbyNodeHelpers.default)({
  typePrefix: `GoogleSheet`
}),
      createNodeFactory = _createNodeHelpers.createNodeFactory;

exports.sourceNodes =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(function* ({
    boundActionCreators
  }, pluginOptions) {
    const createNode = boundActionCreators.createNode;
    const rootName = pluginOptions.rootName || "Sheet";
    const RootNode = createNodeFactory(rootName);
    const doc = new _googleSpreadsheet.default(pluginOptions.spreadsheetKey);

    if (pluginOptions.creds) {
      yield new Promise(resolve => doc.useServiceAccountAuth(pluginOptions.creds, resolve));
    }

    const worksheets = yield new Promise((resolve, reject) => doc.getInfo((err, info) => {
      if (err || !info.worksheets.length) reject(err);
      resolve(info.worksheets);
    }));
    const items = yield worksheets.reduce(
    /*#__PURE__*/
    function () {
      var _ref2 = (0, _asyncToGenerator2.default)(function* (acc, sheet) {
        const rows = yield new Promise((resolve, reject) => {
          sheet.getRows((err, rows) => {
            if (err) reject(err);
            resolve(rows);
          });
        });
        return (yield acc).concat(rows);
      });

      return function (_x3, _x4) {
        return _ref2.apply(this, arguments);
      };
    }(), Promise.resolve([]));
    const rows = items.forEach(item => {
      const itemNode = RootNode(item);
      createNode(itemNode);
    });
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();